/*
 * JavaScript ID3 Tag Reader 0.1.2
 * Copyright (c) 2008 Jacob Seidelin, cupboy@gmail.com, http://blog.nihilogic.dk/
 * MIT License [http://www.opensource.org/licenses/mit-license.php]
 * 
 * Extended by António Afonso (antonio.afonso@opera.com), Opera Software ASA
 */

var ID3 = {};

(function() {
	var files = [];
    
    function getReader(data)
    {
        // FIXME: improve this detection according to the spec
        return data.getStringAt(0, 3) == "ID3" ? ID3v2 : ID3v1;
    }
    
	function readFileData(url, callback, tags) {
	    function read(data) {
	        var reader = getReader(data);
	        var tagsFound = reader.readTagsFromData(data, tags);
			files[url] = tagsFound;
			if (callback) callback();
	    }
	    
	    // FIXME: doesn't make sense, should be able to receive a string
		if( /^mountpoint:\/\//.test(url) ) {
		    readFileDataFromFileSystem(url, read);
		} else {
		    readFileDataFromAjax(url, read);
		}
	}
	
	function readFileDataFromAjax(url, callback) {
	    BinaryAjax(
			url,
			function(http) {
				if (callback) callback(http.binaryResponse);
			}
		)
	}

    function readFileDataFromFileSystem(url, callback) {
        ReadFile(
            url,
            function(file) {
				if (callback) callback(file);
				file.close();
            }
        )
    }
    
    ID3.loadTags = function(url, cb, tags) {
		//if (!files[url]) {
			readFileData(url, cb, tags);
		//} else {
		//	if (cb) cb();
		//}
	}

	ID3.getAllTags = function(url) {
		if (!files[url]) return null;
        
		var tags = {};
		for (var a in files[url]) {
			if (files[url].hasOwnProperty(a))
				tags[a] = files[url][a];
		}
		return tags;
	}

	ID3.getTag = function(url, tag) {
		if (!files[url]) return null;

		return files[url][tag];
	}	
})();

