(function()
{
    var _config = {};
    
    _config.minDuration = 1;
    
    var _form             = document.getElementById('aclForm');
    var _emailShareLink   = document.getElementById('emailShareLink');
    var _magicURLbutton   = document.getElementById('magicURLbutton');
    var _magicURL         = document.getElementById('magicURL');
    var _password_fail    = document.getElementById('password-fail');
    var _inputs = [];
    
    if( !_form )
    {
        return false;
    }

    var _fields = {};
    var _fieldsBackup   = {};
    _fields['accessNode']   = _form['accessNode'].value;
    _fields['unite-nonce']  = _form['unite-nonce'].value;

    var _inProgress     = false;
    var _magic          = _form['magic'].value;
    var _url            = window.Unite.servicePath +'/api/acl/1.0/change';

    var _magicBaseUrl   = 'http://'+window.Unite.serverName+window.Unite.servicePath+'/magic/';

    
    /*
     *  initialize
     */
    function _init()
    {
        //  watch the radio & text inputs
        for(var i=0,e;e=_form.elements[i];i++)
        {
            if( e.type=='radio' || e.type=='text' )
            {
                _inputs.push( e );
                if( e.type=='text' )
                {
                    e.onkeypress = _changeOnEnter;
                    _fields[ e.name ] = e.value;                    
                }
                else if( e.type == 'radio' )
                {
                    e.onchange = _change;
                    if( e.checked )
                    {
                        _fields[ e.name ] = e.value;
                    }
                }
            }
            else if( e.tagName != 'BUTTON' && e.type=='submit' )
            {
                //  remove the submit button
                e.parentNode.removeChild( e );
            }
        }

        // add links events
        var labels = _form.getElementsByClassName("privacyOption");
        for( var i = 0, label; label = labels[i]; i++ )
        {
            var saveButton = label.getElementsByClassName("savePassword")[0];
            var password = label.getElementsByClassName("password")[0];
            var checkbox = label.getElementsByClassName("checkbox")[0];
            
            if( saveButton )
            {
                saveButton.onclick = (function(checkbox) { return function(e)
                {
                    e = e || window.event;
                    e.target.style.display = "none";
                    e.preventDefault();
                    checkbox.checked = true;
                    _change.apply(checkbox, arguments);
                    return false;
                }})(checkbox);
            }
            
            if( password )
            {
                password.onkeypress = function(e)
                {
                    _hideMessage("saved");
                    _showSaveButton();
                    _changeOnEnter.apply(this, arguments);
                }
            }
        }
        _backupFields();
        if(_magicURLbutton)
        {
            _magicURLbutton.onclick = function()
            {
                if(_magicURL.style.display=="block")
                {
                    _magicURL.style.display = "none";
                    _magicURLbutton.className = "magicurlicon";
                } else {
                    _magicURL.style.display = "block";
                    _magicURLbutton.className = "magicurlicon on";
                }
                return false;
            }
        }
    }
    
    
    /*
     *  backup fields
     */
    function _backupFields()
    {
        for( var k in _fields )
        {
            if( k!=='unite-nonce' )
            {
                _fieldsBackup[ k ] = ''+_fields[k];
            }
        }
    }
    /*
     *  restore fields
     */
    function _restoreFields(failMessage)
    {
        for( var k in _fieldsBackup )
        {
            if( k!=='unite-nonce' )
            {
                _fields[ k ] = ''+_fieldsBackup[k];
            }
        }
        for( var i=0,input; input=_inputs[i++]; )
        {
            if( input.type=='radio' )
            {
                input.checked = input.value==_fields['type'];
                input.parentNode.className = input.checked?'checked':'';
            }
            else if( input.name=='password' )
            {
                input.value = _fields['password'];
            }
        }
        if(failMessage=="Bad or missing password")
        {
            _password_fail.style.display = "block";
        }
    }

    /*
     *
     */
    function _change()
    {
        //  check inputs
        var limited = false;
        if( this.name=='password' || (this.name=='type' && this.value=='limited') )
        {
            if( this.name=='password' )
            {
                for( var i=0,input; input=_inputs[i++]; )
                {
                    if( input.name=='type' )
                    {
                        input.checked = input.value=='limited';
                    }
                }
            }
            limited = true;
        }

        //  update _fields
        _fields['type']     = limited?'limited':'public';
        _fields['password'] = _form['password'].value;

        _request( _fields );
    }

    function _changeOnEnter(e)
    {
        var e = e || event;
        
        if( e.keyCode===13 )
        {
            _change.apply(this, arguments);
            return false;
        }
    }
    
    /*
     *
     */
    function _toggleForm( newState )
    {
        _inProgress = newState;
        _form.setAttribute( 'style', 'opacity:'+(_inProgress?1:.33)+';' );
        for( var i=0,input; input=_inputs[i++]; )
        {
            if( input.type=='radio' )
            {
                input.parentNode.className = input.checked?'checked':'';
            }
            input.disabled  = !_inProgress; 
        }
    }

    function _hideMessage( type )
    {
        var messages = _form.getElementsByClassName('message');
		
		for(var i = 0, msg; msg = messages[i]; i++)
		{
		    if( !type || new RegExp("\\b"+type+"\\b").test(msg.className) )
		    {
		        msg.style.display = "none";
		    }
		}
    }
    
    function _showSaveButton()
    {
        var buttons = _form.getElementsByTagName('button');
        
		for(var i = 0, button; button = buttons[i]; i++)
		{
		    if( /\bsavePassword\b/.test(button.className) )
		    {
		        button.style.display = "inline";
		        return;
		    }
		}
    }
    
    function _hideSaveButton()
    {
        var buttons = _form.getElementsByTagName('button');
        
		for(var i = 0, button; button = buttons[i]; i++)
		{
		    if( /\bsavePassword\b/.test(button.className) )
		    {
		        button.style.display = "none";
		        return;
		    }
		}
    }

    /*
     *
     */
    function _request( fields )
    {
        var timeFired = new Date().getTime();
        function _request_readyState()
        {
        	if( this.readyState!==4 )	return false;
            
            var delay = new Date().getTime()-timeFired-_config.minDuration;
            if( delay<0 )
            {
                var method  = arguments.callee;
                var that    = this;
                setTimeout( function(){ method.call(that); },delay )
                return false;
            }
            

            var success = false;
            var failMessage = "";
            if( this.status==200 )
            {
                var xml = this.responseXML;
                if( xml )
                {
                    var newToken = (xml.getElementsByTagName('token')||[{textContent:''}])[0].textContent;
                    if( newToken!=='' )
                    {
                        _fields['unite-nonce'] = newToken;
                        var result = xml.getElementsByTagName('error');
                        if( result.length==0 )
                        {
                            result = xml.getElementsByTagName('success');
                            if( result.length===1 )
                            {
                                var result = result[0].getElementsByTagName('magic');
                                if( result.length==1 )
                                {
                                    _magic = result[0].textContent;
                                    success = true;
                                }
                            }
                        } else {
                            failMessage = result[0].textContent;
                        }
                    }
                }
            }
            _toggleForm( true );
            
            if( success )
            {
				// feedback for user when acl changes.
				var labels = _form.getElementsByTagName('label');
				_hideMessage("saved");
				
				for(var i = 0, label, div; label = labels[i]; i++) (function(label) {
					if (label.className == 'checked') {
					    var message = document.getElementById("saved"+_fields["type"]);
					    message.style.display = "inline";
					    
						label.style.border = '1px solid #709e75';
						setTimeout(function() {
							  label.style.border = '';
						}, 1000);
						
						if( label.getElementsByClassName("savePassword").length > 0 )
						{
						    _hideSaveButton();
						}
            if(_fields["type"] == "public"){
                _magicURLbutton.style.display = "none";
                _magicURL.style.display = "none";
            } else {
                _magicURLbutton.style.display = "block";
            }
					}
				})(label);
				
                _backupFields();
                _form['magicUrl'].value = _magicBaseUrl+_magic;
                if( _emailShareLink )
                {
                    var tmp = _emailShareLink.getAttribute( 'data-href-'+_fields["type"])+'';
                    if( tmp!='' )
                    {
                        _emailShareLink.setAttribute( 'href', tmp.replace( '@', _fields['password'] ) );
                    }
                }
                _password_fail.style.display = "none";
            }
            else
            {
                //  TODO: add some styling showing the failure of the change
                _restoreFields(failMessage);
                //alert( 'ACL CHANGE FAILED\n'+ this.status+'\n \n'+ Array.prototype.map.call( result, function( v ){ return v.nodeName +' = '+ v.textContent; } ).join( '\n' ) +'\n_________\n \n'+ this.responseText );
            }
            return true;
        }

        //  build data from the _fields
        var data = '';
        var t =[];
        for( var k in _fields )t.push( escape(k)+'='+escape(_fields[k]) );
        data    = t.join('&');
        
        //  prepare XHR object and send the request
        var xhr = new XMLHttpRequest();
        xhr.open( 'POST', _url, true );
        xhr.onreadystatechange = _request_readyState;
        xhr.setRequestHeader( 'Content-type', 'application/x-www-form-urlencoded' );
        xhr.setRequestHeader( 'Content-length', data.length);
        xhr.send( data );
        _toggleForm( false );
    }


    //  init
    _init();
})();