Yusef.addPlugin
(
    'directConnection',
    function Yusef_plugins_directConnection()
    {
        var self                = this;
        // key: session id
        // value: timestamp of last ping
        var _status             = {};
        
        var ERR                 = 'Yusef.plugins.directConnection';
        var CLEANUP_INTERVAL    = 10000;

        

        function init()
        {
            var publicHtml  = Yusef.mountpoints.application.resolve( 'libraries/yusef/plugins/directConnection/public_html' );
            Yusef.shareStaticDirectory( publicHtml );
            setInterval( cleanup, CLEANUP_INTERVAL );
        }

        Yusef.addSectionListener
        (
            'direct_connection',
            (function( connection )
            {
                var sid = (connection.request.queryItems['sid']||[])[0];
                
                if( !sid ) { return; }
                
                _status[sid] = new Date().getTime();
                PSO.pub( ERR, 'Registered ' + sid );
            }).bind(this)
        );

        Yusef.extend
        (
            'serveFile',
            function extendedServeFile( connection, file )
            {
                if( redirect( connection ) === false )
                {
                    extendedServeFile.proceed.apply( this, arguments );
                }
            }
        );


        this.getData = function( connection )
        {
            var data = {};

            data.js = 'static/yusef.directConnection.js';

            return data;
        }

        function redirect( connection )
        {
            var directLink = self.getLink( connection );
            
            if( _status[connection.session.id] && directLink && connection.isProxied )
            {
                connection.response.setStatusCode( 302, "Found" );
                connection.response.setResponseHeader( 'Location', directLink );
                connection.response.close();
                return true;
            }
            
            return false;
        }

        this.getLink = function( connection )
        {
            var ip = opera.io.webserver.publicIP;
            var port = opera.io.webserver.publicPort;

            if( ip )
            {
                return "http://" + ip + (port?":"+port:"") + connection.request.uri;
            }        
        }
        
        function cleanup()
        {
            var now = new Date().getTime();
            
            for( var sid in _status )
            {
                if( _status[sid]+CLEANUP_INTERVAL < now )
                {
                    delete _status[sid];
                }
            }
        }
        
        init();
    }
)
